#!/usr/bin/env python

# $Id: L440GX.py,v 1.1 1999/12/07 17:57:02 cvs Exp $

"""Decode the IPMI system event log for L440GX+ motherboard"""

import sys
import string
import time

from L440GX_sensor import *

true, false = 1, 0

while 1:
    line = sys.stdin.readline()
    if not line:
        break
    words = string.split(line)
    if not words: #ignore blank lines
        continue
    if len(words) != 16:
        sys.stderr.write("error: line should contain 16 bytes: "+line)
        continue
    bytes = map(lambda x:string.atoi(x,16), words)
    record_id = bytes[:1]
    record_type = bytes[2]
    timestamp = bytes[3:7]
    gen_id = bytes[8]
    event_format_rev = bytes[9]
    sensor_type = bytes[10]
    sensor_number = bytes[11]
    event_dir = bytes[12] & 0x80
    event_type = bytes[12] &0x7f
    event_data = bytes[13:16]

    if event_format_rev not in (2,3):
        print "Warning: unexpected event format", event_format_rev

    timestamp_valid = true
    oem = false
    if record_type != 2:
        if 0xC0 <= record_type <= 0xDF:
            oem = true
            timestamp_valid = true
        elif 0xE0 <= record_type <= 0xE0:
            oem = true
            timestamp_valid = false

    if timestamp_valid:
        t = timestamp[0] | timestamp[1]<<8 | timestamp[2]<<16 | timestamp[3]<<24
        if t<0x20000000:
            timestring = '%s seconds after SEL init' % t
        else:
            timestring = time.asctime(time.localtime(t))
        print timestring,'\t',

    if oem:
        print "OEM event",
        if timestamp_valid:
            print bytes[7:]
        else:
            print bytes[3:]
        continue

    if event_dir==0:
        print "Assert",
    else:
        print "Deassert",

    s = sensor_dict.get(sensor_type)
    if s is None:
        print "Unknown sensor type ",sensor_type,
    else:
        s2 = s.get(sensor_number)
        if s2 is None:
            s2 = s.get(None)
    
    print s2,
    if sensor_number == 0x25:
        print post_dict.get(tuple(event_data[1:]),
                            "Unknown POST Event "+string.join(map(hex,event_data[1:]))),
                        
    if sensor_number == 0xEF:
        b = bios_dict.get(sensor_type)
        if b is None:
            b2=None
        else:
            b2 = b.get(event_data[0])
        if b2 is None:
            print "Unknown BIOS Event",hex(sensor_type),hex(event_data[0]),
        else:
            print b2,
        if sensor_type == 0x0C and event_data[0] in (0x40, 0x41):
            print "DIMM",event_data[1],

    print
    #print '\t',map(hex,event_data)
    
    
    
    
    
    

        
    
        
        
    
        
